<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>ListType - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="EnumType.html">EnumType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="EnumType.html#getInterpolatedValue">getInterpolatedValue</a></li></ul></li><li><a href="ListType.html">ListType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ListType.html#cost">cost</a></li></ul></li><li><a href="MidiType.html">MidiType</a><ul class='members'></ul></li><li><a href="ModalType.html">ModalType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ModalType.html#getPi">getPi</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getNu">getNu</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getTau">getTau</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getRho">getRho</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getOp">getOp</a></li></ul></li><li><a href="NumericType.html">NumericType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NumericType.html#getNormalized">getNormalized</a></li></ul></li><li><a href="RecordType.html">RecordType</a><ul class='members'></ul></li><li><a href="SetType.html">SetType</a><ul class='members'></ul></li><li><a href="StringType.html">StringType</a><ul class='members'></ul></li><li><a href="SvgType.html">SvgType</a><ul class='members'></ul></li><li><a href="Type.html">Type</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getCheckMessage">getCheckMessage</a></li><li data-type='method' style='display: none;'><a href="Type.html#getDistance">getDistance</a></li><li data-type='method' style='display: none;'><a href="Type.html#getPath">getPath</a></li><li data-type='method' style='display: none;'><a href="Type.html#compare">compare</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBound">getBound</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBounds">getBounds</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getType">getType</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeNames">getTypeNames</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeParameters">getTypeParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#.addType">addType</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#json2midi">json2midi</a></li><li><a href="global.html#json2svg">json2svg</a></li><li><a href="global.html#midi2Jon">midi2Jon</a></li><li><a href="global.html#svg2json">svg2json</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">ListType</h1>
    

    




<section>

<header>
    
        <h2>
        
            ListType
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="ListType"><span class="type-signature"></span>new ListType<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Specifies a list type, i.e. an strictly ordered container of elements.</p>
<h4>Extends: <a href='./Type.html'>Type</a>, with all public methods available.</h4>
<p><a name="parameters"></a></p>
<h2>Type parameters</h2>
<h3>General parameters</h3>
<ul>
<li><code>name: ...</code> The type name. By default the type name is <code>list-of-$itemType</code>.</li>
<li><code>itemType: ...</code> The type elements if any. By default, &quot;value&quot;, means any value.</li>
</ul>
<h3>Parameters for the syntactic projection</h3>
<ul>
<li><code>minLength: ...</code> The minimal number of items in the list. By default <code>0</code>.</li>
<li><code>maxLength: ...</code> The maximal number of items in the list. By default unbounded (<code>-1</code>).</li>
</ul>
<h3>Parameters for the cost calculation</h3>
<ul>
<li><code>deleteCost: ...</code> The non-negative deleting cost value.
<ul>
<li>By default uses the <code>getDistance()</code> between the item and an empty data structure.</li>
</ul>
</li>
<li><code>insertCost: ...</code> The non-negative inserting cost value.
<ul>
<li>By default equals to the <code>deleteCost</code>.</li>
</ul>
</li>
<li><code>editCost: ...</code> The non-negative editing cost value.
<ul>
<li>By default uses the <code>getDistance()</code> between each item.</li>
</ul>
</li>
</ul>
<p><a name="specification"></a></p>
<h2>ListType specification</h2>
<table class="specification">
<tr style='border: 1px solid black;'><th> Syntactic projection </th><td>
- If the value is empty, it corresponds to an empty list.
<br/> - If the value is not a list, it is encapsulated in a <tt>[ value ]</tt> singleton.
<br/> - If the list length is not in the (optional) <tt>[minLength, maxLength]</tt> bounds a message is issued, but the list is neither truncated nor extended.
<br/> - Each list item is syntactically projected.
</td></tr>
<tr style='border: 1px solid black;'><th> Semantic projection  </th><td>
- Each list item is semantically projected.
</td></tr>
<tr style='border: 1px solid black;'><th> Distance value       </th><td>
- The minimal distance is computed using the <a href="https://en.wikipedia.org/wiki/Levenshtein_distance">Levenshtein distance</a> calculation applied on the list element and delegating the edition cost to the item Type distance computation.
<br/> &nbsp;&nbsp;&nbsp;&nbsp; - The algorithmic complexity order of magnitude is thus quadratic with respect to the list length considering the item type complexity as basic operation.
<br/> - The editing distance can be either:
<br/> &nbsp;&nbsp;&nbsp;&nbsp; - parameterized defining fixed deletion, insertion and editing costs, or
<br/> &nbsp;&nbsp;&nbsp;&nbsp; - parameterized rederiving the <a href="#cost">cost()</a> function.
</td></tr>
<tr style='border: 1px solid black;'><th> Geodesic path        </th><td>
- The geodesic path corresponds to the <a href="https://en.wikipedia.org/wiki/Wagner%E2%80%93Fischer_algorithm">Wagner-Fischer algorithm</a> shortest path in the matrix distance yielding to the minimal distance computation.
</td></tr>
<tr style='border: 1px solid black;'><th> Comparison           </th><td>
- Returns <tt>0</tt> If each element pair compares equal and both lists have the same length.
<br/> - Returns <tt><0</tt> If either the value of the first item that does not match is lower in the left hand side list, or all compared items match but the left hand side list is shorter.
<br/> - Returns <tt>>0</tt> If either the value of the first item that does not match is greater in the left hand side list, or all compared items match but the left hand side list is longer.
</td></tr>
<tr style='border: 1px solid black;'><th> Bounds           </th><td>
- Considers all list lengths beetwen `minLength` and `maxLength` to calculate the bounds, from the item type bounds.
</td></tr>
</table></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The type parameters.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="cost"><span class="type-signature"></span>cost<span class="signature">(what, lhs, i, rhs, j)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Cost function of the editing distance</p>
<ul>
<li>The <code>ListType::cost()</code> implements the <code>deleteCost</code>, <code>insertCost</code> and <code>editCost</code> parameters related cost.</li>
<li>A typical re-implementation is of the form:</li>
</ul>
<pre class="prettyprint source"><code>class MyListType : public ListType {
../..
  double cost(char what, JSON lhs, unsigned int i, JSON rhs, unsigned int j) const {
   // Implements the MyListType specific features, if appropriate and returns the value
   return ListType::cost(what, lhs, i, rhs, j); // Delegates to the parent implementation otherwise
 }
}
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>what</code></td>
            

            <td class="type">
            
                
<span class="param-type">char</span>



            
            </td>

            

            

            <td class="description last"><p>The editing operation:</p>
<ul>
<li>'d' : deletion cost for the <code>lhs[i]</code> value.</li>
<li>'i' : insertion cost for the <code>rhs[j]</code> value.</li>
<li>'e' : edition cost to transform the <code>lhs[i]</code> to <code>rhs[j]</code></li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>lhs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The left hand-size value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>i</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The lhs index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>rhs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The right hand-size value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>j</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The rhs index.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The cost value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>